# -*- coding: utf-8 -*-
# cython: language_level=2
# =====================================================================================================================
# These bindings were automatically generated by cyWrap. Please do dot modify.
# Additional functionality shall be implemented in sub-classes.
#
__copyright__ = "Copyright 2016 EPFL BBP-project"
# =====================================================================================================================
from cython.operator cimport dereference as deref
cimport std
from libcpp cimport bool
from steps_common cimport *

# ======================================================================================================================
cdef extern from "util/init.hpp" namespace "steps":
# ----------------------------------------------------------------------------------------------------------------------
    ###### Static funcs ######
    void init()


# ======================================================================================================================
cdef extern from "util/finish.hpp" namespace "steps":
# ----------------------------------------------------------------------------------------------------------------------
    ###### Static funcs ######
    void finish()


# ======================================================================================================================
cdef extern from "util/error.hpp" namespace "steps":
# ----------------------------------------------------------------------------------------------------------------------

    ###### Cybinding for Err ######
    cdef cppclass Err(std.runtime_error):
        Err(std.string)
        char* getMsg()
        char* what()

    cdef cppclass AssertErr(Err):
        AssertErr(std.string)

    ###### Cybinding for NotImplErr ######
    cdef cppclass NotImplErr(Err):
        NotImplErr(std.string)

    ###### Cybinding for ProgErr ######
    cdef cppclass ProgErr(Err):
        ProgErr(std.string)

    ###### Cybinding for SysErr ######
    cdef cppclass SysErr(Err):
        SysErr(std.string)

    ###### Cybinding for IOErr ######
    cdef cppclass IOErr(Err):
        IOErr(std.string)


# ======================================================================================================================
cdef extern from "util/checkid.hpp" namespace "steps::util":
# ----------------------------------------------------------------------------------------------------------------------

        void checkID(char *) except +
        void checkID(std.string) except +


# ======================================================================================================================
cdef extern from "math/ghk.hpp" namespace "steps::math":
# ----------------------------------------------------------------------------------------------------------------------
    double permeability(double G, double V, int z, double T, double iconc, double oconc)


# ======================================================================================================================
cdef extern from "util/vocabulary.hpp" namespace "steps":
# ----------------------------------------------------------------------------------------------------------------------

    cdef cppclass triangle_global_id:
        triangle_global_id()
        triangle_global_id(index_t)
        ulong get()

    cdef cppclass tetrahedron_global_id:
        tetrahedron_global_id()
        tetrahedron_global_id(index_t)
        index_t get()

    cdef cppclass vertex_id_t:
        vertex_id_t()
        vertex_id_t(index_t)
        index_t get()

    cdef cppclass bar_id_t:
        bar_id_t()
        bar_id_t(index_t)
        index_t get()

# ======================================================================================================================
cdef extern from "util/vocabulary.hpp" namespace "steps::model":
# ----------------------------------------------------------------------------------------------------------------------

    cdef enum Location:
        COMP
        PATCH_IN
        PATCH_SURF
        PATCH_OUT


# ======================================================================================================================
cdef extern from "solver/fwd.hpp" namespace "steps::solver":
# ----------------------------------------------------------------------------------------------------------------------

    cdef cppclass spec_local_id:
        spec_local_id()
        spec_local_id(index_t)
        index_t get()

    cdef cppclass vesicle_individual_id:
        vesicle_individual_id()
        vesicle_individual_id(index_t)
        ulong get()
        bool valid()

    cdef cppclass raft_individual_id:
        raft_individual_id()
        raft_individual_id(index_t)
        ulong get()
        bool valid()

    cdef cppclass comp_global_id:
        comp_global_id()
        comp_global_id(index_t)
        index_t get()

    cdef cppclass patch_global_id:
        patch_global_id()
        patch_global_id(index_t)
        index_t get()

    cdef cppclass linkspec_individual_id:
        linkspec_individual_id()
        linkspec_individual_id(index_t)
        ulong get()
        bool valid()

    cdef cppclass pointspec_individual_id:
        pointspec_individual_id()
        pointspec_individual_id(index_t)
        ulong get()
        bool valid()

    cdef cppclass ExocytosisEvent:
        double time
        vesicle_individual_id vidx
        triangle_global_id tidx
        raft_individual_id ridx

    cdef cppclass RaftEndocytosisEvent:
        double time
        raft_individual_id ridx
        triangle_global_id tidx
        vesicle_individual_id vidx

    cdef cppclass EndocytosisEvent:
        double time
        triangle_global_id tidx
        vesicle_individual_id vidx
