###___license_placeholder___###

def tetmesh2metis(mesh, ofile):
    """
    Convert STEPS Tetmesh data to metis connectivity data.
    
    Parameters:
    * mesh   STEPS Tetmesh object
    * ofile  Output file name.
    
    Return:
    None
    """
    
    with open(ofile, 'w') as out:
        ntets = mesh.ntets
        out.write("%i\n" % (ntets))
        for t in range(ntets):
            #tet_vol = mesh.getTetVol(t)
            #out.write('%e ' % (tet_vol))
            tet_vertices = mesh.getTet(t)
            for v in tet_vertices:
                out.write("%i " % (v + 1))
            out.write("\n")

def readPartition(partition_file):
    """
    Load partition information from Metis .epart file.
        
    Parameters:
        * partition_file   .epart file generated by Metis.
        
    Return:
        partition list for parallel TetOpsplit solver
    """
    partition = []
    with open(partition_file, 'r') as parts:
        for line in parts:
            partition.append(int(line))
    return partition
