# -*- coding: utf-8 -*-
# =====================================================================================================================
# These bindings were automatically generated by cyWrap. Please do dot modify.
# Additional functionality shall be implemented in sub-classes.
#
__copyright__ = "Copyright 2016 EPFL BBP-project"
# =====================================================================================================================
from libcpp cimport bool
from libcpp.memory cimport shared_ptr
from libcpp.pair cimport pair
cimport std
cimport steps
cimport steps_solver
cimport steps_model
cimport steps_dist_tetmesh
cimport steps_wm
cimport steps_rng
from steps_common cimport *
from steps_dist cimport *

# ======================================================================================================================
cdef extern from "math/distributions.hpp" namespace "steps::math":
# ----------------------------------------------------------------------------------------------------------------------

    cdef enum DistributionMethod:
        UNIFORM "steps::math::DistributionMethod::DIST_UNIFORM",
        MULTINOMIAL "steps::math::DistributionMethod::DIST_MULTINOMIAL"

# ======================================================================================================================
cdef extern from "mpi/dist/tetopsplit/fwd.hpp" namespace "steps::dist":
# ----------------------------------------------------------------------------------------------------------------------

    cdef cppclass SSAMethod_SSA "steps::dist::SSAMethod::SSA":
        pass

    cdef cppclass SSAMethod_RSSA "steps::dist::SSAMethod::RSSA":
        pass

    cdef cppclass NextEventSearchMethod_Direct "steps::dist::NextEventSearchMethod::Direct":
        pass

    cdef cppclass NextEventSearchMethod_GibsonBruck "steps::dist::NextEventSearchMethod::GibsonBruck":
        pass


# ======================================================================================================================
cdef extern from "mpi/dist/tetopsplit/simulation.hpp" namespace "steps::dist":
# ----------------------------------------------------------------------------------------------------------------------
    cdef struct MembraneResistivity:
        double resistivity
        double reversal_potential

# ======================================================================================================================
cdef extern from "mpi/dist/tetopsplit/tetopsplit.hpp" namespace "steps::dist":
# ----------------------------------------------------------------------------------------------------------------------
    ###### Cybinding for TetOpSplit ######
    cdef cppclass TetOpSplitBase:
        std.string getSolverName() except +
        std.string getSolverDesc() except +
        std.string getSolverAuthors() except +
        std.string getSolverEmail() except +
        void reset() except +
        void run(double) except +
        void checkpoint(std.string) except +
        void restore(std.string) except +
        double getTime() except +
        uint getNSteps() except +
        void setTime(double) except +
        void setNSteps(uint) except +

        std.vector[double] getBatchTetSpecCounts(std.vector[GO], std.string, bool) except +
        void setBatchTetSpecCounts(std.vector[GO], std.string, std.vector[double], bool) except +
        std.vector[double] getBatchTetSpecConcs(std.vector[GO], std.string, bool) except +
        void setBatchTetSpecConcs(std.vector[GO], std.string, std.vector[double], bool) except +
        std.vector[double] getBatchTriSpecCounts(std.vector[GO], std.string, bool) except +
        void setBatchTriSpecCounts(std.vector[GO], std.string, std.vector[double], bool) except +

        void getBatchTetSpecCountsNP(GO*, int, std.string, double*, int, bool) except +
        void setBatchTetSpecCountsNP(GO*, int, std.string, double*, int, bool) except +
        void getBatchTetSpecConcsNP(GO*, int, std.string, double*, int, bool) except +
        void setBatchTetSpecConcsNP(GO*, int, std.string, double*, int, bool) except +
        void getBatchTriSpecCountsNP(GO*, int, std.string, double*, int, bool) except +
        void setBatchTriSpecCountsNP(GO*, int, std.string, double*, int, bool) except +

        void getBatchVertVsNP(GO*, int, double*, int, bool) except +
        void getBatchTriVsNP(GO*, int, double*, int, bool) except +
        void getBatchTetVsNP(GO*, int, double*, int, bool) except +

        void getBatchTriOhmicIsNP(GO*, int, std.string, double*, int, bool) except +
        void getBatchTriComplexOhmicIsNP(GO*, int, std.string, double*, int, bool) except +
        void getBatchTriGHKIsNP(GO*, int, std.string, double*, int, bool) except +
        void getBatchTriComplexGHKIsNP(GO*, int, std.string, double*, int, bool) except +

        void setDiffBoundarySpecDiffusionActive(std.string, std.string, bool) except +
        bool getDiffBoundarySpecDiffusionActive(std.string, std.string) except +

        void setDiffApplyThreshold(int) except +
        int getDiffApplyThreshold() except +

        unsigned long long getReacExtent(bool) except +
        unsigned long long getDiffExtent(bool) except +

        double getNIteration() except +
        double getUpdPeriod() except +
        double getCompTime() except +
        double getSyncTime() except +
        double getIdleTime() except +
        double getRDTime() except +
        double getDiffusionTime() except +
        double getReactionTime() except +
        double getDataExchangeTime() except +

        void setMembIClamp(std.string, double) except +
        MembraneResistivity getTriRes(GO, bool) except +
        void setTriRes(GO, double, double, bool) except +
        double getTriCapac(GO, bool) except +
        void setTriCapac(GO, double, bool) except +
        double getVertIClamp(GO, bool) except +
        void setVertIClamp(GO, double, bool) except +
        double getTriOhmicErev(GO, std.string, bool) except +
        void getBatchTriOhmicErevsNP(GO*, int, std.string, double*, int, bool) except +
        void setTriOhmicErev(GO, std.string, double, bool) except +
        double getTriComplexOhmicErev(GO, std.string, bool) except +
        void getBatchTriComplexOhmicErevsNP(GO*, int, std.string, double*, int, bool) except +
        void setTriComplexOhmicErev(GO, std.string, double, bool) except +
        double getEfieldDT() except +
        void setEfieldDT(double) except +
        void setPetscOptions(std.string) except +
        void setTemp(double) except +
        double getTemp() except +

        # Not sure they are all mandatory
        double getCompVol(std.string) except +
        double getCompSpecCount(std.string, std.string) except +
        void setCompSpecCount(std.string, std.string, double, DistributionMethod) except +
        double getCompAmount(std.string, std.string) except +
        void setCompAmount(std.string, std.string, double) except +
        double getCompSpecConc(std.string, std.string) except +
        void setCompSpecConc(std.string, std.string, double, DistributionMethod) except +
        double getCompComplexCount(std.string, std.string, std.vector[std.vector[steps_model.SubunitStateFilter]]) except +
        void setCompComplexCount(std.string, std.string, std.vector[std.vector[steps_model.SubunitStateFilter]], double n, DistributionMethod) except +
        double getCompComplexSUSCount(std.string, std.string, std.vector[std.vector[steps_model.SubunitStateFilter]], uint) except +
        double getPatchComplexCount(std.string, std.string, std.vector[std.vector[steps_model.SubunitStateFilter]]) except +
        void setPatchComplexCount(std.string, std.string, std.vector[std.vector[steps_model.SubunitStateFilter]], double n, DistributionMethod) except +
        double getPatchComplexSUSCount(std.string, std.string, std.vector[std.vector[steps_model.SubunitStateFilter]], uint) except +
        bool getCompClamped(std.string, std.string) except +
        void setCompClamped(std.string, std.string, bool) except +
        double getCompReacK(std.string, std.string) except +
        void setCompReacK(std.string, std.string, double) except +
        bool getCompReacActive(std.string, std.string) except +
        void setCompReacActive(std.string, std.string, bool) except +
        double getTetSpecCount(uint, std.string, bool) except +
        void setTetSpecCount(uint, std.string, double, bool) except +
        double getTetSpecConc(uint, std.string, bool) except +
        void setTetSpecConc(uint, std.string, double, bool) except +
        double getPatchArea(std.string) except +
        double getPatchSpecCount(std.string, std.string) except +
        void setPatchSpecCount(std.string, std.string, double, DistributionMethod) except +
        double getPatchAmount(std.string, std.string) except +
        void setPatchAmount(std.string, std.string, double) except +
        bool getPatchClamped(std.string, std.string) except +
        void setPatchClamped(std.string, std.string, bool) except +
        double getPatchSReacK(std.string, std.string) except +
        void setPatchSReacK(std.string, std.string, double) except +
        bool getPatchSReacActive(std.string, std.string) except +
        void setPatchSReacActive(std.string, std.string, bool) except +
        double getTriSpecCount(uint, std.string, bool) except +
        void setTriSpecCount(uint, std.string, double, bool) except +
        double getVertV(GO, bool) except +
        double getTriV(GO, bool) except +
        double getTetV(GO, bool) except +
        double getTriOhmicI(GO, std.string, bool) except +
        double getTriComplexOhmicI(GO, std.string, bool) except +
        double getTriGHKI(GO, std.string, bool) except +
        double getTriComplexGHKI(GO, std.string, bool) except +
        void setMembPotential(std.string, double) except +
        void setMembRes(std.string, double, double) except +
        MembraneResistivity getMembRes(std.string) except +
        void dumpDepGraphToFile(std.string) except +

    cdef cppclass TetOpSplit[T, U]:
        TetOpSplit(steps_model.Model&, steps_dist_tetmesh.DistMesh&, shared_ptr[steps_rng.RNG], bool, bool) except +
