# -*- coding: utf-8 -*-
# =====================================================================================================================
# These bindings were automatically generated by cyWrap. Please do dot modify.
# Additional functionality shall be implemented in sub-classes.
#
__copyright__ = "Copyright 2016 EPFL BBP-project"
# =====================================================================================================================
from cython.operator cimport dereference as deref
from libcpp cimport bool
from libcpp.memory cimport shared_ptr
from libcpp.pair cimport pair
cimport std
cimport steps_solver
cimport steps_model
cimport steps_tetmesh
cimport steps_wm
cimport steps_rng
from steps_common cimport *
from steps cimport index_t


# ======================================================================================================================
cdef extern from "tetexact/tetexact.hpp" namespace "steps::tetexact":
# ----------------------------------------------------------------------------------------------------------------------
    # ctypedef uint SchedIDX
    # ctypedef std.set[uint] SchedIDXSet
    # ctypedef std.set[uint].iterator SchedIDXSetI
    # ctypedef std.set[uint].const_iterator SchedIDXSetCI
    # ctypedef std.vector[uint] SchedIDXVec
    # ctypedef std.vector[uint].iterator SchedIDXVecI
    # ctypedef std.vector[uint].const_iterator SchedIDXVecCI

    ###### Cybinding for Tetexact ######
    cdef cppclass Tetexact:
        # Heavily modified by Iain
        Tetexact(steps_model.Model*, steps_wm.Geom*, shared_ptr[steps_rng.RNG], int) except +
        std.string getSolverName() except +
        std.string getSolverDesc() except +
        std.string getSolverAuthors() except +
        std.string getSolverEmail() except +
        void checkpoint(std.string) except +
        void restore(std.string) except +
        void reset() except +
        void run(double) except +
        void advance(double) except +
        void step() except +
        void setEfieldDT(double) except +
        void setNSteps(uint) except +
        void setTime(double) except +
        void setTemp(double) except +
        double getTime() except +
        double getEfieldDT() except +
        double getTemp() except +
        double getA0() except +
        uint getNSteps() except +
        double getCompVol(std.string) except +
        double getCompSpecCount(std.string, std.string) except +
        void setCompSpecCount(std.string, std.string, double) except +
        double getCompSpecAmount(std.string, std.string) except +
        void setCompSpecAmount(std.string, std.string, double) except +
        double getCompSpecConc(std.string, std.string) except +
        void setCompSpecConc(std.string, std.string, double) except +
        bool getCompSpecClamped(std.string, std.string) except +
        void setCompSpecClamped(std.string, std.string, bool) except +
        double getCompReacK(std.string, std.string) except +
        void setCompReacK(std.string, std.string, double) except +
        bool getCompReacActive(std.string, std.string) except +
        void setCompReacActive(std.string, std.string, bool) except +
        double getCompDiffD(std.string, std.string) except +
        void setCompDiffD(std.string, std.string, double) except +
        bool getCompDiffActive(std.string, std.string) except +
        void setCompDiffActive(std.string, std.string, bool) except +
        double getCompReacC(std.string, std.string) except +
        double getCompReacH(std.string, std.string) except +
        double getCompReacA(std.string, std.string) except +
        unsigned long long getCompReacExtent(std.string, std.string) except +
        void resetCompReacExtent(std.string, std.string) except +
        double getTetVol(uint) except +
        void setTetVol(uint, double) except +
        bool getTetSpecDefined(uint, std.string) except +
        double getTetSpecCount(uint, std.string) except +
        void setTetSpecCount(uint, std.string, double) except +
        double getTetSpecAmount(uint, std.string) except +
        void setTetSpecAmount(uint, std.string, double) except +
        double getTetSpecConc(uint, std.string) except +
        void setTetSpecConc(uint, std.string, double) except +
        bool getTetSpecClamped(uint, std.string) except +
        void setTetSpecClamped(uint, std.string, bool) except +
        double getTetReacK(uint, std.string) except +
        void setTetReacK(uint, std.string, double) except +
        bool getTetReacActive(uint, std.string) except +
        void setTetReacActive(uint, std.string, bool) except +
        double getTetDiffD(uint, std.string, uint) except +
        void setTetDiffD(uint, std.string, double, uint) except +
        bool getTetDiffActive(uint, std.string) except +
        void setTetDiffActive(uint, std.string, bool) except +
        double getTetReacC(uint, std.string) except +
        double getTetReacH(uint, std.string) except +
        double getTetReacA(uint, std.string) except +
        double getTetDiffA(uint, std.string) except +
        double getTetV(uint) except +
        void setTetV(uint, double) except +
        bool getTetVClamped(uint) except +
        void setTetVClamped(uint, bool) except +
        double getPatchArea(std.string) except +
        double getPatchSpecCount(std.string, std.string) except +
        void setPatchSpecCount(std.string, std.string, double) except +
        double getPatchSpecAmount(std.string, std.string) except +
        void setPatchSpecAmount(std.string, std.string, double) except +
        bool getPatchSpecClamped(std.string, std.string) except +
        void setPatchSpecClamped(std.string, std.string, bool) except +
        double getPatchSReacK(std.string, std.string) except +
        void setPatchSReacK(std.string, std.string, double) except +
        bool getPatchSReacActive(std.string, std.string) except +
        void setPatchSReacActive(std.string, std.string, bool) except +
        double getPatchSReacC(std.string, std.string) except +
        double getPatchSReacH(std.string, std.string) except +
        double getPatchSReacA(std.string, std.string) except +
        unsigned long long getPatchSReacExtent(std.string, std.string) except +
        void resetPatchSReacExtent(std.string, std.string) except +
        bool getPatchVDepSReacActive(std.string, std.string) except +
        void setPatchVDepSReacActive(std.string, std.string, bool) except +
        void setDiffBoundarySpecDiffusionActive(std.string, std.string, bool) except +
        bool getDiffBoundarySpecDiffusionActive(std.string, std.string) except +
        void setDiffBoundarySpecDcst(std.string, std.string, double, std.string) except +
        void setSDiffBoundarySpecDiffusionActive(std.string, std.string, bool) except +
        bool getSDiffBoundarySpecDiffusionActive(std.string, std.string) except +
        void setSDiffBoundarySpecDcst(std.string, std.string, double, std.string) except +
        double getTriArea(uint) except +
        void setTriArea(uint, double) except +
        bool getTriSpecDefined(uint, std.string) except +
        double getTriSpecCount(uint, std.string) except +
        void setTriSpecCount(uint, std.string, double) except +
        double getTriSpecAmount(uint, std.string) except +
        void setTriSpecAmount(uint, std.string, double) except +
        bool getTriSpecClamped(uint, std.string) except +
        void setTriSpecClamped(uint, std.string, bool) except +
        double getTriSReacK(uint, std.string) except +
        void setTriSReacK(uint, std.string, double) except +
        bool getTriSReacActive(uint, std.string) except +
        void setTriSReacActive(uint, std.string, bool) except +
        double getTriSReacC(uint, std.string) except +
        double getTriSReacH(uint, std.string) except +
        double getTriSReacA(uint, std.string) except +
        double getTriSDiffD(uint, std.string, uint) except +
        void setTriSDiffD(uint, std.string, double, uint) except +
        double getTriV(uint) except +
        void setTriV(uint, double) except +
        bool getTriVClamped(uint) except +
        void setTriVClamped(uint, bool) except +
        double getTriOhmicErev(uint, std.string) except +
        void setTriOhmicErev(uint, std.string, double) except +
        double getTriOhmicI(uint) except +
        double getTriOhmicI(uint, std.string) except +
        double getTriGHKI(uint) except +
        double getTriGHKI(uint, std.string) except +
        double getTriI(uint) except +
        void setTriIClamp(uint, double) except +
        bool getTriVDepSReacActive(uint, std.string) except +
        void setTriVDepSReacActive(uint, std.string, bool) except +
        double getVertV(uint) except +
        void setVertV(uint, double) except +
        bool getVertVClamped(uint) except +
        void setVertVClamped(uint, bool) except +
        void setVertIClamp(uint, double) except +
        void setMembPotential(std.string, double) except +
        void setMembCapac(std.string, double) except +
        void setMembVolRes(std.string, double) except +
        void setMembRes(std.string, double, double) except +
        pair[double, double] getMembRes(std.string) except +
        std.vector[double] getBatchTetSpecCounts(std.vector[index_t], std.string) except +
        std.vector[double] getBatchTriSpecCounts(std.vector[index_t], std.string) except +
        void getBatchTetSpecCountsNP(index_t*, int, std.string, double*, int) except +
        void getBatchTriSpecCountsNP(index_t*, int, std.string, double*, int) except +
        std.vector[double] getROITetSpecCounts(std.string, std.string) except +
        std.vector[double] getROITriSpecCounts(std.string, std.string) except +
        void getROITetSpecCountsNP(std.string, std.string, double*, int) except +
        void getROITriSpecCountsNP(std.string, std.string, double*, int) except +
        double getROIVol(std.string) except +
        double getROIArea(std.string) except +
        double getROISpecCount(std.string, std.string) except +
        void setROISpecCount(std.string, std.string, double) except +
        double getROISpecAmount(std.string, std.string) except +
        void setROISpecAmount(std.string, std.string, double) except +
        double getROISpecConc(std.string, std.string) except +
        void setROISpecConc(std.string, std.string, double) except +
        void setROISpecClamped(std.string, std.string, bool) except +
        void setROIReacK(std.string, std.string, double) except +
        void setROISReacK(std.string, std.string, double) except +
        void setROIDiffD(std.string, std.string, double) except +
        void setROIReacActive(std.string, std.string, bool) except +
        void setROISReacActive(std.string, std.string, bool) except +
        void setROIDiffActive(std.string, std.string, bool) except +
        void setROIVDepSReacActive(std.string, std.string, bool) except +
        unsigned long long getROIReacExtent(std.string, std.string) except +
        void resetROIReacExtent(std.string, std.string) except +
        unsigned long long getROISReacExtent(std.string, std.string) except +
        void resetROISReacExtent(std.string, std.string) except +
        unsigned long long getROIDiffExtent(std.string, std.string) except +
        void resetROIDiffExtent(std.string, std.string) except +
        void saveMembOpt(std.string) except +
